;Juego de luces que simula las de una ambulancia.Dos que hacen de rotativo
;y dos que hacen de estroboscopio.

LIST P = 12f508



INCLUDE <P12f508.inc>

__CONFIG _CP_OFF & _WDT_OFF & _MCLRE_OFF & _IntRC_OSC

contador equ	0x09		;Los valores alto1 y alto2 marcan el tiempo que los leds del rotativo
alto1	equ	0x0A		;estan encendidos. A mayor valor, mayor tiempo encendido y mas brillo.
bajo1	equ	0x0B
alto2	equ	0x0C
bajo2	equ	0x0D

Reset
		ORG	00h
		movlw	0x80
		movwf	OSCCAL

Inicio		movlw	b'00001000'
		TRIS	6
		clrf	GPIO
		nop
		nop
		movlw	b'11000111'
	;	movlw	b'11000000'
			OPTION
		nop
		clrf	GPIO
			

Parado		bsf	GPIO,1		;encendido del estrobo 1
		movlw	d'0'
		movwf   alto1
		movlw	d'10'
		movwf   alto2
		call	Retardo05
		bcf	GPIO,1		;apagado del estrobo 1
		movlw	d'1'
		movwf   alto1
		movlw	d'4'
		movwf   alto2
		call	Retardo05
	
		bsf	GPIO,1
		movlw	d'2'
		movwf   alto1
		movlw	d'3'
		movwf   alto2
		call	Retardo05
		movlw	d'3'
		movwf   alto1
		movlw	d'2'
		movwf   alto2
		bcf	GPIO,1
		call	Retardo05
	
		bsf	GPIO,1
		movlw	d'4'
		movwf   alto1
		movlw	d'1'
		movwf   alto2
		call	Retardo05
		movlw	d'10'
		movwf   alto1
		movlw	d'0'
		movwf   alto2
		bcf	GPIO,1
		call	Retardo05

		bsf	GPIO,0		;encendido del estrobo 2
		movlw	d'10'
		movwf   alto1
		movlw	d'0'
		movwf   alto2
		call	Retardo05
		movlw	d'4'
		movwf   alto1
		movlw	d'1'
		movwf   alto2
		bcf	GPIO,0		;apagado del estrobo 2
		call	Retardo05
	
		bsf	GPIO,0
		movlw	d'3'
		movwf   alto1
		movlw	d'2'
		movwf   alto2
		call	Retardo05
		movlw	d'2'
		movwf   alto1
		movlw	d'3'
		movwf   alto2
		bcf	GPIO,0
		call	Retardo05
	
		bsf	GPIO,0
		movlw	d'1'
		movwf   alto1
		movlw	d'4'
		movwf   alto2
		call	Retardo05
		bcf	GPIO,0
		movlw	d'0'
		movwf   alto1
		movlw	d'10'
		movwf   alto2
		call	Retardo05
		
		goto	Parado





Retardo05	movlw	d'95'            ;valor para ajustar frecuencia
		movwf	TMR0
		movlw	d'10'
		movwf   contador
Retardo1	movf	contador,0
		subwf   alto1,0
		btfsc	STATUS,C
		goto	pon1
		bcf	GPIO,4
vuelta1		movf    contador,0
		subwf   alto2,0
		btfsc	STATUS,C
		goto	pon2
		bcf	GPIO,5
vuelta2		decfsz	contador,1
		goto    continuar
		movlw	d'10'
		movwf   contador

continuar	movf	TMR0,0
		btfss	STATUS, Z
		goto	Retardo1
		return
pon1		bsf	GPIO,4
		goto	vuelta1
pon2		bsf	GPIO,5
		goto	vuelta2

END
